Hello,

Please look at the minimal working example below.

GNU bash, version 5.1.16(1)-release (x86_64-pc-linux-gnu)
Ubuntu 22.04.5 LTS

*01a.sh*

#!/bin/bash
set -e

echo "01a - 1 "
./02.sh
echo "01a - 2 "

*01b.sh*

#!/bin/bash
set -e

echo "01b - 1 "
./02.sh && echo "You will not see this"
echo "01b - 2 "

*02.sh*

#!/bin/bash
set -e

echo "02 - 1"
set +e
this_command_does_not_exist
RESULT=$?
set -e
echo "02 - 2 RESULT=$RESULT"
exit $RESULT

Outputs:

# ./01a.sh
01a - 1
02 - 1
./02.sh: line 6: this_command_does_not_exist: command not found
02 - 2 RESULT=127

# ./01b.sh 127 ↵
01b - 1
02 - 1
./02.sh: line 6: this_command_does_not_exist: command not found
02 - 2 RESULT=127
01b - 2

The 01a.sh script exists with code 127, the01b.sh script exists with code 0.

The only difference between them is that 01a.sh executes./02.shbut 01b.sh executes ./02.sh && echo "You will not see this"

According to the current bash documentation (output of "man bash"):

> An AND list has the form
>
>               command1 && command2
>
>        command2 is executed if, and only if, command1 returns an exit status of zero (success).
>
>        An OR list has the form
>
>               command1 || command2
>
>        command2  is  executed  if,  and only if, command1 returns a non-zero exit status. *The return status of AND and OR lists is the exit status of the last*
> *command executed in the list.*

I think that there is a bug:

 * ./02.shreturns error code 127
 * ./02.sh && echo "You will not see this"should also return exit code
   127 (because second command in the list is not executed)
 * echo "01b - 2 "*should not be executed*, because "set -e" was
   specified, but in reality it is executed
 * The exit code of01b.shshould be 127 but in reality it is zero

Please let me know if this is indeed a bug.

Thank you,


--
*Nagy László Zsolt*
Szoftver tervező
Informatikai Fejlesztési Intézet, Eszterházy Károly Egyetem
--
*Nagy László Zsolt*
Software architect
Software Development Institute, Eszterházy Károly University
H-3300 Eger, Leányka utca 4.

Reply via email to